#
# db2_secured::controls::set_maximum_connection_limits_max_connections_and_max_coordagents
#
# @summary 
# Puppet controls are Puppet defined types that ensure a certain security control is implemented. Puppet changes the system in order to make the system compliant.## Description of the controlTODO: Write documentation## Rationale## SkippingTo deliberately skip this control (e.g. meaning don't use Puppet to enforce this setting), we provideyou with two ways:1) Add `db2_secured::controls::set_maximum_connection_limits_max_connections_and_max_coordagents: skip` to your hiera data. This will skip this control for **ALL** systems.  3) Add an entry with the content `set_maximum_connection_limits_max_connections_and_max_coordagents` to the array value `db2_secured::skip_list` in your hiera data.  ## BenchmarksThis control is used in the following benchmarks:- [db11 CIS V1.0.0](/docs/db2_secured/cis/db11_V1.0.0.html) - paragraph 3.1.8
#
# @param title
#    The database identifier to apply the control to.
#    All controls need an database identifier to apply the control to. Here is a simple example:
#    ``` puppet
#    db2_secured::controls::control_name { 'db2inst1/MYDB':}
#    ```
#    In this example, the string `dbinst1` is the instance, the string `MYDB` is the database to apply the control to.
#
#
# See the file "LICENSE" for the full license governing this code.
#
define db2_secured::controls::set_maximum_connection_limits_max_connections_and_max_coordagents (
  Integer $preferred_value = db2_secured::lookup_setting('preferred_value', 200),
) {
  $elements = $title.split('/')
  $instance = $elements[0]
  $lower_value = $preferred_value -1

  db2_secured_setup { "set_maximum_connection_limits_max_connections_and_max_coordagents on ${title}":
    ensure => 'present',
  }

  resource_value { "Db2_instance[${instance}]max_coordagents":
    allow_create   => true,
    allow_redefine => true,
    value          => $preferred_value,
  }

  resource_value { "Db2_instance[${instance}]max_connections":
    allow_create   => true,
    allow_redefine => true,
    value          => -1,
  }
}
